---
title: Xamarin.Android error XA5301
description: XA5301 error code
ms.date: 08/13/2019
---
# Xamarin.Android error XA5301

## Issue

The XA5301 error is generated from a Windows [MAX_PATH][MAX_PATH]
failure: a file path over 260 characters was encountered somewhere
throughout the build.

Consider submitting a [bug][bug] if you are getting this failure under
normal circumstances.

## Solution

Rename your project to have a shorter name, or move the entire
solution to a shorter path.

For example:

    C:\Users\MyReallyLongUsername\Desktop\Code\MyReallyLongSolutionName

May fit under the [MAX_PATH][MAX_PATH] limit if it was instead:

    C:\Code\MyReallyLongSolutionName

Alternatively in recent versions of Windows 10, you can opt into long
paths via a [Local Group Policy][long_path] system-wide.

[bug]: https://github.com/xamarin/xamarin-android/wiki/Submitting-Bugs,-Feature-Requests,-and-Pull-Requests
[MAX_PATH]: https://docs.microsoft.com/en-us/windows/win32/fileio/naming-a-file#maximum-path-length-limitation
[long_path]: https://blogs.msdn.microsoft.com/jeremykuhne/2016/07/30/net-4-6-2-and-long-paths-on-windows-10/
